package buffer;
import junit.framework.TestCase;

public class BufferBlockTest extends TestCase {
	final static int TIMEOUT = 500;
	public void testTakeBlocksWhenEmpty() {
		final BoundedBuffer<Integer> bb = new BoundedBuffer<Integer>(10);
		Thread taker = new Thread() {
			public void run() {
				try {
					int unused = bb.take();
					fail();
				} catch(InterruptedException success){}
			}
		};
		try {
			taker.start();
			Thread.sleep(TIMEOUT);
			taker.interrupt();
			taker.join(TIMEOUT);
			assertFalse(taker.isAlive());
		}catch(Exception unexpected){
			fail();
		}
	}
}
